﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BLL.Interface;
using DAL.Interface;
using Model;

namespace BLL.Implementation {
  public class PedidoBO: IPedidoBO {
    #region IPedidoBO Members
    
    private IPedidoDAO _pedidoDAO;
    public IPedidoDAO pedidoDAO{
      set {_pedidoDAO = value;}
    }
    
    private IItemPedidoDAO _itemPedidoDAO;
    public IItemPedidoDAO itemPedidoDAO{
      set {_itemPedidoDAO = value;}
    }

    public void inserirPedido(Model.Pedido p) {
      //Calcula automaticamente o valor total do cabeçalho do pedido baseado nos itens. 
      //Só pra exemplificar uma regra de negócio.
      float valorTotal = 0;
      foreach(ItemPedido ip in p.Itens){
        valorTotal += (ip.Quantidade * ip.PrecoUnitario);
      }
      p.ValorTotal = valorTotal;
      
      //Persiste o pedido e seus itens.
      _pedidoDAO.inserirPedido(p);
      foreach(ItemPedido ip in p.Itens){
        ip.PedidoID = p.PedidoID; //Passa o ID com autoincremento para os filhos.
        _itemPedidoDAO.InserirItemPedido(ip);
      }
    }

    public Pedido pegarPedidoPorID(int PedidoID) {
      Pedido p = _pedidoDAO.pegarPorID(PedidoID);
      p.Itens = _itemPedidoDAO.LerPorPedidoID(p.PedidoID);
      return p;
    }

    #endregion
  }
}
