﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DAL.Interface;
using Model;

namespace DAL.Memoria {
  public class ItemPedidoDAO : IItemPedidoDAO {
    #region IItemPedidoDAO Members
    
    private Dictionary<int, ItemPedido> _itens = new Dictionary<int, ItemPedido>();

    public void InserirItemPedido(Model.ItemPedido ip) {
      //Autoincremento
      int max = 0;
      foreach (KeyValuePair<int, ItemPedido> pair in _itens) {
        if (pair.Key > max)
          max = pair.Key;
      }
      ip.ItemPedidoID = max + 1;
      _itens.Add(ip.ItemPedidoID, ip);
    }

    public void AlterarItemPedido(Model.ItemPedido ip) {
      if (!_itens.ContainsKey(ip.ItemPedidoID))
        throw new Exception("Não existe item de pedido com o ID " + ip.ItemPedidoID.ToString());

      _itens[ip.ItemPedidoID] = ip;
    }

    public void ExcluirItemPedido(Model.ItemPedido ip) {
      if (!_itens.ContainsKey(ip.ItemPedidoID))
        throw new Exception("Não existe item de pedido com o ID " + ip.ItemPedidoID.ToString());

      _itens.Remove(ip.ItemPedidoID);
    }

    public List<Model.ItemPedido> LerPorPedidoID(int PedidoID) {
      List<ItemPedido> result = 
        (from KeyValuePair<int, ItemPedido> pair in _itens
         where pair.Value.PedidoID == PedidoID
         select pair.Value).ToList<ItemPedido>();
        
      return result;
    }

    #endregion
  }
}
