﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DAL.Interface;
using Model;

namespace DAL.Memoria {
  public class PedidoDAO: IPedidoDAO {
    #region IPedidoDAO Members
    
    private Dictionary<int, Pedido> _pedidos = new Dictionary<int,Pedido>();       

    public void inserirPedido(Model.Pedido p) {
      //Autoincremento
      int max = 0;
      foreach(KeyValuePair<int, Pedido> pair in _pedidos){
        if (pair.Key > max)
          max = pair.Key;
      }
      p.PedidoID = max + 1;      
      _pedidos.Add(p.PedidoID, p);
    }

    public void alterarPedido(Model.Pedido p) {
      if (!_pedidos.ContainsKey(p.PedidoID))
        throw new Exception("Não existe pedido com o ID " + p.PedidoID.ToString());
            
      _pedidos[p.PedidoID] = p;
    }

    public void excluirPedido(Model.Pedido p) {
      if (!_pedidos.ContainsKey(p.PedidoID))
        throw new Exception("Não existe pedido com o ID " + p.PedidoID.ToString());
        
      _pedidos.Remove(p.PedidoID);
    }

    public Model.Pedido pegarPorID(int PedidoID) {
      if (!_pedidos.ContainsKey(PedidoID))
        return null;
      
      return _pedidos[PedidoID];
    }

    #endregion
  }
}
