﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DAL.Interface;
using System.Web.SessionState;
using System.Web;
using Model;

namespace DAL.Session {
  public class ItemPedidoSessionDAO : IItemPedidoDAO {
    #region IItemPedidoDAO Members    

    public void InserirItemPedido(Model.ItemPedido ip) {
      //Autoincremento
      int max = 0;
      foreach (string k in HttpContext.Current.Session.Keys) {
        if (!k.StartsWith("ItemPedido_"))
          continue;
        ItemPedido iped = (ItemPedido)HttpContext.Current.Session[k];
        if (iped.ItemPedidoID > max)
          max = iped.ItemPedidoID;
      }
      ip.ItemPedidoID = max + 1;

      HttpContext.Current.Session["ItemPedido_" + ip.ItemPedidoID.ToString()] = ip;
    }

    public void AlterarItemPedido(Model.ItemPedido ip) {
      if (HttpContext.Current.Session["ItemPedido_" + ip.ItemPedidoID.ToString()] == null)
        throw new Exception("Não existe item de pedido com o ID " + ip.ItemPedidoID.ToString());

      HttpContext.Current.Session["ItemPedido_" + ip.ItemPedidoID.ToString()] = ip;
    }

    public void ExcluirItemPedido(Model.ItemPedido ip) {
      if (HttpContext.Current.Session["ItemPedido_" + ip.ItemPedidoID.ToString()] == null)
        throw new Exception("Não existe item de pedido com o ID " + ip.ItemPedidoID.ToString());

      HttpContext.Current.Session.Remove("ItemPedido_" + ip.ItemPedidoID.ToString());
    }

    public List<Model.ItemPedido> LerPorPedidoID(int PedidoID) {
      List<ItemPedido> result = new List<ItemPedido>();
      foreach (string k in HttpContext.Current.Session.Keys) {
        if (!k.StartsWith("ItemPedido_"))
          continue;

        ItemPedido ip = (ItemPedido)HttpContext.Current.Session[k];
        if (ip.PedidoID == PedidoID)
          result.Add(ip);
      }
      return result;
    }

    #endregion
  }
}
