﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DAL.Interface;
using System.Web;
using System.Web.SessionState;
using Model;

namespace DAL.Session {
  public class PedidoSessionDAO : IPedidoDAO {

    #region IPedidoDAO Members       
    
    public void inserirPedido(Model.Pedido p) {
      //Autoincremento
      int max = 0;      
      foreach (string k in HttpContext.Current.Session) {
        if (!k.StartsWith("Pedido_"))
          continue;
        Pedido ped = (Pedido)HttpContext.Current.Session[k];
        if (ped.PedidoID > max)
          max = ped.PedidoID;
      }      
      p.PedidoID = max + 1;

      HttpContext.Current.Session["Pedido_" + p.PedidoID.ToString()] = p;
    }

    public void alterarPedido(Model.Pedido p) {
      if (HttpContext.Current.Session["Pedido_" + p.PedidoID.ToString()] == null)
        throw new Exception("Não existe pedido com o ID " + p.PedidoID.ToString());

      HttpContext.Current.Session["Pedido_" + p.PedidoID.ToString()] = p;
    }

    public void excluirPedido(Model.Pedido p) {
      if (HttpContext.Current.Session["Pedido_" + p.PedidoID.ToString()] == null)
        throw new Exception("Não existe pedido com o ID " + p.PedidoID.ToString());

      HttpContext.Current.Session.Remove("Pedido_" + p.PedidoID.ToString());
    }

    public Model.Pedido pegarPorID(int PedidoID) {
      return (Pedido)HttpContext.Current.Session["Pedido_" + PedidoID.ToString()];                    
    }

    #endregion
  }
}
